Name:           ocaml-qtest
Version:        2.9
Release:        7%{?dist}
Summary:        Inline (Unit) Tests for OCaml

License:        GPLv3+
URL:            https://github.com/vincent-hugot/qtest
Source0:        https://github.com/vincent-hugot/qtest/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  ocaml
BuildRequires:  ocaml-dune
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ounit-devel >= 2.0.0
BuildRequires:  ocaml-qcheck >= 0.5
BuildRequires:  help2man


%description
qtest extracts inline unit tests written using a special syntax in
comments. Those tests are then run using the oUnit framework and the
qcheck library. The possibilities range from trivial tests -- extremely
simple to use -- to sophisticated random generation of test cases.


%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}


%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.


%prep
%setup -q -n qtest-%{version}


%build
dune build @install --profile release


%install
dune install --destdir="%{buildroot}" --verbose

# These files will be installed using the doc and license directives
rm %{buildroot}/usr/doc/qtest/{LICENSE,README.adoc}

# Makes *.cmxs executable such that they will be stripped.
find %{buildroot} -name '*.cmxs' -exec chmod 0755 {} \;

# generate manpage
mkdir -p %{buildroot}/%{_mandir}/man1/
help2man %{buildroot}/%{_bindir}/qtest \
    --output %{buildroot}/%{_mandir}/man1/qtest.1 \
    --name "Inline (Unit) Tests for OCaml" \
    --version-string %{version} \
    --no-info


%check
make test -W build # ignore dependency on "build" target


%files
%doc README.adoc HOWTO.adoc
%license LICENSE
%{_bindir}/qtest
%{_mandir}/man1/qtest.1*
%{_libdir}/ocaml/qtest
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/qtest/lib/*.a
%exclude %{_libdir}/ocaml/qtest/lib/*.cmxa
%exclude %{_libdir}/ocaml/qtest/lib/*.cmx
%endif

%files devel
%doc README.adoc HOWTO.adoc
%license LICENSE
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/qtest/lib/*.a
%{_libdir}/ocaml/qtest/lib/*.cmxa
%{_libdir}/ocaml/qtest/lib/*.cmx
%endif

%changelog
* Fri Nov 29 2019 Andy Li <andy@onthewings.net> - 2.9-7
- Remove unused BuildRequires on opam-installer.
- BuildRequires on ocaml-dune instead of jbuilder.

* Tue Aug 06 2019 Andy Li <andy@onthewings.net> - 2.9-6
- OCaml 4.08.1 rebuild.

* Mon Jul 29 2019 Andy Li <andy@onthewings.net> - 2.9-5
- Update build depends and commands from jbuilder to dune.

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.9-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.9-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri May 18 2018 Andy Li <andy@onthewings.net> - 2.9-1
- New upstream release (RHBZ#1570332).
- Enable devel and debug packages.

* Fri Apr 06 2018 Andy Li <andy@onthewings.net> - 2.8-1
- New upstream release.
- Remove ocaml-qtest-LICENSE.patch which has been applied upstream.

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Nov 23 2017 Andy Li <andy@onthewings.net> - 2.7-1
- Initial RPM release.
